#!/bin/bash
# this script periodically copies index.htm to the specified directory
# (default species so links will be valid). Starts at 1.htm and increments,
# current count in rechistory.ini file (delete to start over). To stop
# recording delete the stophistory file (or if in a term, control-C).
# ------------------------------------
interval=600  #seconds
histdir="../species"  #directory to save history to
# ------------------------------------
grapdir="$histdir/files"  #directory to save graphics to
graphic="../files/maezumo.jpg"  #filename for graphics (copied one time)
index="../index.htm"  #path/name of Maezumo index file
n=1  #numbering start
cd `dirname $0`
echo "Copying $index to $histdir every $interval seconds"
if [ ! -e "$histdir" ]; then
 mkdir "$histdir"
fi
echo "Copying $graphic to $grapdir"
if [ ! -e "$grapdir" ]; then
 mkdir "$grapdir"
fi
cp "$graphic" "$grapdir"
echo "delete this to stop history" > "stophistory"
echo "Delete the stophistory file to stop recording"
while [ -e "stophistory" ]; do
 if [ -e "rechistory.ini" ]; then
  read n dummy < "rechistory.ini"
  echo "copying $index to $histdir/$n.htm"
  cp "$index" "$histdir/$n.htm"
  n=$[ $n + 1 ]
  echo $n > "rechistory.ini"
  sleep $interval
 else
  echo $n > "rechistory.ini"
 fi
done

